#ifndef CGUL_RANDOM_WELL32_P_H
#define CGUL_RANDOM_WELL32_P_H

#include "cgul_common.h"
#include "cgul_random_well32.h"

CGUL_BEGIN_C

/**
 * Data encapsulated by the <code>cgul_random_well32</code> class.
 */
struct cgul_random_well32 {

    /**
     * The vector that holds the internal state.
     */
    cgul_uint32_t* state;

    /**
     * The vector that holds PRNs that are waiting to be tempered and
     * returned to the user.
     */
    cgul_uint32_t* v;

    /**
     * The index into v.
     */
    int v_index;

};

CGUL_END_C

#endif  /*  CGUL_RANDOM_WELL32_P_H  */
