#include <iostream>
#include "cgul_cxx.h"

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    cgul_string_cxx s;
    cgul_bdf_cxx bdf;

    try {

        /* Load the font. */
        bdf.load("dejavu_sans-14.bdf");

        s = "Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.  Now is the time for all good men to come to the aid of their country.";

        /* Wrap the string. */
#if 1
        cgul_line_wrapper_cxx::wrap_utf8_at_width(s,
                                                   bdf,
                                                   1,    /* substitute */
                                                   640);
#else
        cgul_line_wrapper_cxx::wrap_utf8_at_column(s, 40);
#endif

        /* Print the results. */
        printf("%s\n", s.get_value());

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
